package org.lazywizard.versionchecker;

import java.awt.Color;
import com.fs.starfarer.api.BaseModPlugin;
import com.fs.starfarer.api.EveryFrameScript;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.CampaignUIAPI;
import org.apache.log4j.Level;

public final class VCModPlugin extends BaseModPlugin
{
    @Override
    public void onApplicationLoad() throws Exception
    {
        Global.getLogger(VCModPlugin.class).log(Level.ERROR,
                "Version Checker is installed incorrectly!");
    }

    @Override
    public void onGameLoad()
    {
        Global.getSector().addTransientScript(new WarnInvalidUpdateScript());
    }

    private static class WarnInvalidUpdateScript implements EveryFrameScript
    {
        private float timeUntilWarn = 1f;
        private boolean isDone = false;

        @Override
        public boolean isDone()
        {
            return isDone;
        }

        @Override
        public boolean runWhilePaused()
        {
            return true;
        }

        @Override
        public void advance(float amount)
        {
            CampaignUIAPI ui = Global.getSector().getCampaignUI();
            if (Global.getSector().isInNewGameAdvance() || ui.isShowingDialog())
            {
                return;
            }

            timeUntilWarn -= amount;
            if (timeUntilWarn <= 0f)
            {
                isDone = true;
                ui.addMessage("Version Checker is not installed correctly!", Color.RED);
                ui.addMessage("Check the forum thread for installation instructions.", Color.RED);
            }
        }

    }
}
